//Distributed under Kellen's sort-of-free license.
//http://people.colgate.edu/kmyers/license.html
//(c) Kellen Myers and Joseph Parrish 2007

// vim:set ts=4:

int f_prelude_len = 4;
char f_prelude[] = {
	// li r4, 0
	0x38, 0x80, 0x00, 0x00,
};

int f_term_init_len = 4;
char f_term_init[] = {
	// li r5, 1
	0x38, 0xa0, 0x00, 0x01,
};

int f_term_set_constant_len = 4;
char f_term_set_constant[] = {
	// li r6, 4
	0x38, 0xc0, 0x00, 0x04,
};

// FIXME: NOTE constant limit of +-32k.
void f_fill_constant(int c)
{
	short x = (short)c;
	f_term_set_constant[2] = (x >> 8) & 0xff;
	f_term_set_constant[3] = x & 0xff;
}

int f_term_get_var_len = 4;
char f_term_get_var[] = {
	// lwz r6, 4(r3)
	0x80, 0xc3, 0x00, 0x04,
};

void f_fill_var_num(int x)
{
	x--; x *= 4;
	f_term_get_var[2] = (x >> 8) & 0xff;
	f_term_get_var[3] = x & 0xff;
}

int f_mul_len = 4;
char f_mul[] = {
	// mullw r5, r5, r6
	0x7c, 0xa5, 0x31, 0xd6,
};

int f_add_len = 4;
char f_add[] = {
	// add r4, r4, r5
	0x7c, 0x84, 0x2a, 0x14,
};

int f_return_len = 8;
char f_return[] = {
	// mr r3, r4
	0x7c, 0x83, 0x23, 0x78,
	// blr
	0x4e, 0x80, 0x00, 0x20,
};

