//Distributed under Kellen's sort-of-free license.
//http://people.colgate.edu/kmyers/license.html
//(c) Kellen Myers and Joseph Parrish 2007

// returns a percentage of the search-space covered so far.
float color_progress(coloring_t *c);
// same as above, but ignore first n elements.
float color_progress_2(coloring_t *c, int n);

// returns the number of elements in the coloring whose color
//   is the same as the final element.
int num_in_color(coloring_t *c);

// dumps the coloring to the screen.
void color_dump(coloring_t *c);
// dumps the coloring to a string.
int color_dump_2(coloring_t *c, char *buf, int len);

// dumps the variable values to the screen.
void var_dump(int *var_array, int num_vars);

